/****************************************************************************/
/* T  v																	*/
/*       vsprintf ̑ւ													*/
/*   																	*/
/*       stdio  vsprintf() ł̓gpʂ 4k  ram ɓ肫	*/
/*       Ȃ\̂ŁAgp@\Ɍ肵 RfVsprinf() p	*/
/*       B																*/
/* 쐬F 2013.06.01														*/
/* XVF 2014.02.02														*/
/* Copyrightresove															*/
/****************************************************************************/
#include <stdarg.h>
#include "RfGeneral.h"
#include "DebugFunc.h"

/* ̃f[^^ */
enum {
	SRC_NON = 0,
	SRC_CHAR,
	SRC_INT,
	SRC_LONG,
	SRC_PTR
};

enum {
	FORM_NON = 0,
	FORM_UDEC,
	FORM_DEC,
	FORM_HEX,
	FORM_CHAR,
	FORM_STRING,
	FORM_ERR
};

/********************************************************************/
/*		֐		 											*/
/********************************************************************/
/****************************************************************************/
/* T  v																	*/
/*        vsprintf() ̋@\											*/
/* p[^																*/
/*        pBuff  FҏW̃obt@											*/
/*        pFormatFprintf Ɠl̃tH[}bgw蕶					*/
/*        bufSizeFpBuff ̃TCY											*/
/*        argptr Fσp[^Xg										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
//int RfVsPrintf( char * pBuff, const char * pFormat, int bufSize, va_list argptr )
int RfVsPrintf( char * pBuff, const char * pFormat, int bufSize, va_list argptr )
{
	int i;
	int ixDist = 0;
	int ixSrc = 0;
	char * pArg;
	unsigned long intArg = 0L;
	char srcType;
	char format;
	char longType;
	char ch;
	char digit = 0;
	char supplyChar = ' ';
	char zeroFill = FALSE;
	int  val;
	int supplyFlag = FALSE;
	int dispDigit = FALSE;
	int negSign = FALSE;
	unsigned long digitIx;
	static const char hexCharS[] = "0123456789abcdef";
	static const char hexCharL[] = "0123456789ABCDEF";
	const char * hexChar;

	char * nowSp = GetSp();
	for( ; ; )
	{
		/* tH[}bgwȊÕRs[ */
		for( ; ; )
		{
			if((pFormat[ixSrc] == '\0') || (pFormat[ixSrc] == '%'))
			{
				break;
			}
			pBuff[ixDist] = pFormat[ixSrc];
			ixSrc++;
			ixDist++;
		}
		if( pFormat[ixSrc] == '\0' )
		{
			pBuff[ixDist] = '\0';			/* I[o */
			break;
		}

		ixSrc++;
		supplyChar = ' ';
		supplyFlag = FALSE;
		negSign = FALSE;			/* 	*/
		format = FORM_NON;
		longType = FALSE;
		zeroFill = FALSE;
		digit = 0;
		srcType = SRC_INT;
		/* tH[}bg */
		for(i = 0; (i < 5) && ( format == FORM_NON ) ; i++ )
		{
			ch = pFormat[ixSrc];
			switch( ch )
			{
			case 'c':
				srcType = SRC_LONG;
				format = FORM_CHAR;
				break;
			case 'x':
				hexChar = hexCharS;
				/* ɔ */
			case 'X':
				hexChar = hexCharL;
				format = FORM_HEX;
				break;
			case 'u':
				format = FORM_UDEC;
				break;
			case 'd':
				format = FORM_DEC;
				break;
			case 's':
				srcType = SRC_PTR;
				format = FORM_STRING;
				break;
			case '0':
				supplyChar = '0';
				zeroFill = TRUE;
				break;
			case 'l':
				srcType = SRC_LONG;
				break;
			default:
				if( (ch >= '1') && (ch <= '9') )
				{
					digit = ch & 0x0f;
				}
				else
				{
					format = FORM_ERR;
				}
				break;
			}
			ixSrc++;
		}

		/* ҏW */
		if( srcType == SRC_PTR )
		{
			/*  */
			pArg = (char*)va_arg(argptr, char *);
		}
		else if( srcType == SRC_CHAR )
		{
			intArg = (unsigned long)va_arg(argptr, int);
		}
		else if( srcType == SRC_INT )
		{
			intArg = (unsigned long)va_arg(argptr, int);		/* int  4 oCgňĂ */
			if( format == FORM_UDEC )
			{
				intArg &= 0x00ffff;
			}
		}
		else if( srcType == SRC_LONG )
		{
			intArg = (unsigned long)va_arg(argptr, long);
		}


		/* tH[}bgɍ킹ĕҏW */
		if( format == FORM_CHAR )
		{
			/* 1 */
			pBuff[ixDist] = (char)intArg;
			ixDist++;
		}
		else if( format == FORM_STRING )
		{
			/*  */
			for(i = 0; pArg[i] != '\0'; i++)
			{
				if( ixDist >= bufSize )
				{
					break;
				}
				pBuff[ixDist] = pArg[i];
				ixDist++;
			}
		}
		else if( format == FORM_HEX )
		{
			/* HEX */
			dispDigit = FALSE;
			digitIx = 0x10000000UL;
			for( i = 0; i < 8; i++ )
			{
				if( digitIx <= 1UL )
				{
					dispDigit = TRUE;
				}
				if( (8-i) <= digit )
				{
					dispDigit = TRUE;
				}
				val = ( intArg / digitIx ) % 0x10UL;
				if( (val != 0 ) || (dispDigit == TRUE) )
				{
					pBuff[ixDist] = hexChar[val];
					ixDist++;
					dispDigit = TRUE;
				}
				digitIx /= 0x0010UL;
			}
		}
		else if( ( format == FORM_DEC ) || ( format == FORM_UDEC ) )
		{
			if( format == FORM_DEC )
			{
				if( (long)intArg < 0L )
				{
					negSign = TRUE;
					intArg = 0L - (long)intArg;
				}
			}
			/* 10i */
			dispDigit = FALSE;
			digitIx = 1000000000UL;
			for( i = 0; i < 10; i++ )
			{
				if( digitIx <= 1UL )
				{
					dispDigit = TRUE;
				}
				if( (10-i) <= digit )
				{
					supplyFlag = TRUE;
				}
				val = ( intArg / digitIx ) % 10UL;
				if( (val != 0 ) || (dispDigit == TRUE) )
				{
					if( negSign == TRUE )
					{
						pBuff[ixDist] = '-';
						ixDist++;
						negSign = FALSE;
					}
					pBuff[ixDist] = val | '0';
					ixDist++;
					dispDigit = TRUE;
				}
				else if( supplyFlag == TRUE )
				{
					pBuff[ixDist] = supplyChar;
					ixDist++;
				}
				digitIx /= 10UL;
			}
		}
	}
	return ixDist;
}
