/****************************************************************************/
/* T  vF DMAhCo														*/
/*   F DMA gp̂߂̒`B											*/
/* 쐬F 2013.07.23														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/
#include	"DrvDma.h"


/****************************************************************************/
/* T  v																	*/
/*        DMAV[gAhX[hŎgp邽߂̏Ȃ		*/
/* p[^																*/
/*        ioAddr FI/O ̃AhX											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        V[gAhX[hp̏֐BI/O AhXݒ肷B	*/
/*        IO AhX͖ݒ肷Kv̂ŏŃZbgĂB	*/
/****************************************************************************/
void initDmaShort( volatile struct st_sam * dmaAddr,volatile void * ioAddr )
{
	dmaAddr->IOAR = (unsigned char)((unsigned long)(ioAddr) & 0x00ffUL);	/* I/OWX^ */
}

/****************************************************************************/
/* T  v																	*/
/*        DMA̐ݒANȂ											*/
/* p[^																*/
/*        mode   F][h												*/
/*                 DMA_MODE_...  DMA_FACT_...  OR Őݒ肷B			*/
/*        dmaAddrFDMA WX^̃AhX									*/
/*        pMem   FAhX											*/
/*        len    F]TCY												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        V[gAhX[hp̐ݒ֐BݒȂƂ	*/
/*        DMA NB													*/
/*         DTE = 0 ̏Ԃ DTIE = 1 ƂƑ荞݂Ă܂̂	*/
/*        n߂ DTE  DTIE ȊÕrbgZbgĂ DTE Zbg	*/
/*        DTC 𓮍삳B̌ADTIE = 1 ƂĊ荞݋ƂB		*/
/*         As[g[hł DTIE = 1 ƂȂB					*/
/****************************************************************************/
void startDmaShort( volatile struct st_sam * dmaAddr, unsigned char mode, char * pMem, unsigned short len )
{
	dmaAddr->MAR = pMem;								/* Mobt@AhX */
	dmaAddr->ETCR = len;								/* Mf[^ */
	dmaAddr->DTCR.BYTE = (unsigned char)(mode &
				 		(~(DMA_DTCR_DTIE|DMA_DTCR_DTE)));/* DTE,DTIE ͍Ōɐݒ肷 */
	dmaAddr->DTCR.BIT.DTE = 1;							/* Cl[u	*/
	dmaAddr->DTCR.BYTE |= (unsigned char)(mode & DMA_DTCR_DTIE);	/* 荞݋	*/

}

/****************************************************************************/
/* T  v																	*/
/*        DMA荞ݗvNA											*/
/* p[^																*/
/*        dmaAddrFDMA WX^̃AhX									*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void clearDmaFactor(volatile struct st_sam * dmaAddr)
{
	dmaAddr->DTCR.BIT.DTIE = 0;
}

/****************************************************************************/
/* T  v																	*/
/*        DMA]cTCY擾										*/
/* p[^																*/
/*        dmaAddrFDMA WX^̃AhX									*/
/* ߂l																	*/
/*        ]cTCY													*/
/*   																	*/
/****************************************************************************/
unsigned short getDmaRemain(volatile struct st_sam * dmaAddr)
{
	return dmaAddr->ETCR;
}

/****************************************************************************/
/* T  v																	*/
/*        DMA~														*/
/* p[^																*/
/*        dmaAddrFDMA WX^̃AhX									*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void stopDma(volatile struct st_sam * dmaAddr)
{
	dmaAddr->DTCR.BIT.DTE = 0;							/* ~	*/
	dmaAddr->DTCR.BIT.DTIE = 0;							/* 荞݋֎~	*/
}
