/****************************************************************************/
/* T  vF DMAhCo														*/
/*   F DMA gp̂߂̒`B											*/
/* 쐬F 2013.07.23														*/
/* XVF 2013.09.30														*/
/* Copyright    resove														*/
/****************************************************************************/
#ifndef DRV_DMA_H
#define DRV_DMA_H

#include	"3048F.H"

/********************************************************/
/* }N												*/
/********************************************************/

/* DMA Nv */
#define DMA_FACT_ITU0		( 0 )				/* ITU0 ̃RyA}b`荞 */
#define DMA_FACT_ITU1		( 1 )				/* ITU1 ̃RyA}b`荞 */
#define DMA_FACT_ITU2		( 2 )				/* ITU2 ̃RyA}b`荞 */
#define DMA_FACT_ITU3		( 3 )				/* ITU3 ̃RyA}b`荞 */
#define DMA_FACT_SCI0_SND	( 4 )				/* SCI1 ̑Mobt@GveB荞 */
#define DMA_FACT_SCI0_RCV	( 5 )				/* SCI0 ̎Mobt@t荞 */
#define DMA_FACT_DREQ_DWN	( 6 )				/* DREQ ̗GbW */
#define DMA_FACT_DREQ_LOW	( 7 )				/* DREQ  low x*/

/* DMA  DTCR WX^rbgʒu */
#define DMA_DTCR_DTS0		( 0x01 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTS1		( 0x02 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTS2		( 0x04 )			/* f[^gXt@[ZNg */
#define DMA_DTCR_DTIE		( 0x08 )			/* 荞݋					*/
#define DMA_DTCR_RPE		( 0x10 )			/* s[g[h				*/
#define DMA_DTCR_DTID		( 0x20 )			/* MAR CNg^fNg*/
#define DMA_DTCR_DTSZ		( 0x40 )			/* f[^TCY					*/
#define DMA_DTCR_DTE		( 0x80 )			/* Cl[u					*/

/* DMA ̃[h */
#define DMA_MODE_IDLE		( DMA_DTCR_RPE|DMA_DTCR_DTIE )	/* ACh[h */
#define DMA_MODE_REPEAT		( DMA_DTCR_RPE )	/* s[g[h */
#define DMA_MODE_IO			( DMA_DTCR_DTIE )	/* I/O [h */

#define DMA_MODE_WORD		( DMA_DTCR_DTSZ )	/* f[^TCY = WORD	*/
#define DMA_MODE_INC		( 0 )				/* MAR CNg	*/
#define DMA_MODE_DEC		( DMA_DTCR_DTID )	/* MAR fNg		*/


/********************************************************/
/* ֐^錾											*/
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif

void initDmaShort( volatile struct st_sam * dmaAddr,
									volatile void * ioAddr );	/* DMA V[gAhX[h̏ */
void startDmaShort( volatile struct st_sam * dmaAddr,
							unsigned char mode,
							char * pMem,
							unsigned short len );				/* DMA V[gAhX[hŋN */
void clearDmaFactor(volatile struct st_sam * dmaAddr);			/* 荞ݗvNA	*/
void stopDma(volatile struct st_sam * dmaAddr);					/* DMA ~			*/
unsigned short getDmaRemain(volatile struct st_sam * dmaAddr);	/* ]̎cTCY擾	*/

#endif	/* #ifndef DRV_DMA_H */
