/****************************************************************************/
/* T  vF o														*/
/*   F timerADMAADA ̃ytFgpĉ炷B				*/
/*          ܂AmFp sin g̏o͂ȂB							*/
/* 쐬F 2013.09.28														*/
/* XVF 2013.09.28														*/
/* Copyright    resove 														*/
/****************************************************************************/
#include "DrvCpuXtal.h"
#include "DrvDma.h"
#include "soundOut.h"

#include "TraceOut.h"


static unsigned long initWaveSize;			/* g`f[^̃TCY		*/
static unsigned long waveSize;				/* g`f[^̎cTCY	*/
static unsigned short inBuffSize;			/*  DMA ]TCY	*/
static char waveBuffer[1024];				/* ]obt@				*/
static volatile unsigned short dmaRepeatFlag = FALSE;

static T_GET_FUNC * pgGetFunc;				/* f[^擾֐			*/
static T_PROGRESS_FUNC * pgProgress;		/* iʒm֐				*/


#define ITU_COUNT_1_NS(n)	(unsigned short)((n)*( CPU_XTAL    /1000000L)/1000L-1L)	/* ns P   62.5ns<= n <  4,096S */
#define SAMPLING_TIME		90703L			/* 90,703 ns */

/****************************************************************************/
/* T  v																	*/
/*        Đ̃f[^[												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        1024 byte ̃obt@ 512 ~ 2 ̃_uobt@ƂĎgpB	*/
/*        O̍ĐIOɌ㔼̑̃f[^[B	*/
/*        lɌ㔼̍ĐI㔼ɑȎ[B		*/
/*        f[^Ȃ܂ŌJԂB									*/
/*        f𔻒fBL[͂ƍĐ𒆒fB					*/
/****************************************************************************/
unsigned short continuePlay( void )
{
	unsigned long wishTakeLen;
	unsigned long takeLen;
	unsigned short err;
	unsigned short success = TRUE;
	unsigned short getSize = 512;

	while( waveSize != 0UL )
	{
		/* obt@O]I҂ */
		while( (getDmaRemain(&DMAC1A) > 256 ) &&	/* ]̎cTCY擾 256 word */
			   ( debugKbHit() == FALSE ) );
		if( debugKbHit() == TRUE )
		{
			operationIn( );									/* ǂݎ̂Ă */
			operationOut("playWave() break1.\n");
			success = FALSE;
			break;
		}

		/* DMA ]̃TCY߂ */
		if( waveSize != 0xffffffffUL )
		{
			if( waveSize >= 1024UL )
			{
				inBuffSize = 1024;
				waveSize -= 1024UL;
			}
			else
			{
				inBuffSize = (unsigned short)waveSize;
				waveSize = 0UL;
			}
			if( pgProgress != NULL )
			{
				pgProgress( initWaveSize - waveSize );
			}
		}
		else
		{
			inBuffSize = 1024;
		}

		/* O󂢂̂Ńf[^ǂݎ */
		if( inBuffSize < 512 )
		{
			getSize = inBuffSize;
		}
		(*pgGetFunc)(waveBuffer, getSize);			/* obt@OɊi[ */

		if( inBuffSize <= 512 )
		{
			/* I */
			while( (dmaRepeatFlag == FALSE) &&	/* DMA ]I҂	*/
				   ( debugKbHit() == FALSE ) );
			success = TRUE;
			break;
		}
		else
		{
			/* 㔼 */
			/* 㔼]I҂ */
			while( (dmaRepeatFlag == FALSE) &&	/* ]̎cTCY擾	*/
				   ( debugKbHit() == FALSE ) );
			dmaRepeatFlag = FALSE;
			if( debugKbHit() == TRUE )
			{
				operationIn( );									/* ǂݎ̂Ă */
				operationOut("playWave() break2.\n");
				success = FALSE;
				break;
			}

			if( inBuffSize < 1024 )
			{
				getSize = inBuffSize - 512;
			}
			(*pgGetFunc)(&waveBuffer[512], getSize);	/* obt@㔼Ɋi[ */
		}
	}

	return success;
}


/****************************************************************************/
/* T  v																	*/
/*        ̏o͊Jn														*/
/* p[^																*/
/*        pGetFuncFf[^擾֐											*/
/*        sizeFf[^TCY												*/
/* ߂l																	*/
/*        TRUEFAFALSEFs											*/
/*   																	*/
/*        o͂NB												*/
/****************************************************************************/
unsigned short startPlay( T_GET_FUNC * pGetFunc, T_PROGRESS_FUNC * pProgress, unsigned long size )
{
	pgGetFunc = pGetFunc;
	pgProgress = pProgress;
	inBuffSize = (*pgGetFunc)(waveBuffer, 1024);

	if( inBuffSize == 0 )
	{
		return FALSE;
	}

	waveSize = size;				/* g`f[^̃TCY */
	initWaveSize = size;			/* g`f[^̃TCY */
	if( pgProgress != NULL )
	{
		pgProgress( 0UL );
	}


	dmaRepeatFlag = FALSE;

	DA.DR0 = 128;
	DA.DR1 = 128;
	DA.CR.BIT.DAE = 1;				/* DA Cl[u */
	DA.CR.BIT.DAOE1 = 1;			/* DA1 o̓Cl[u */
	DA.CR.BIT.DAOE0 = 1;			/* DA0 o̓Cl[u */
	
	/* ^C}DMA N */
 	ITU.TSTR.BIT.STR2 = 0; 							/* ITU2 ~		*/

	ITU2.TCNT = 0;									/* JE^NA	*/
	ITU2.TCR.BIT.CCLR = 1;							/* count clear at GRA compare match */
	ITU2.TCR.BIT.CKEG = 0; 							/* count at upper edge */
	ITU2.TCR.BIT.TPSC = 0; 							/* internal clock / 1 */
	ITU2.GRA = ITU_COUNT_1_NS(90703L);				/* 90,703 nsec(11,025Hz) */
	ITU2.TIER.BIT.IMIEA = 1;						/* GRA RyA}b`荞݋		*/

	initDmaShort( &DMAC1A, &DA.DR0 );				/* DMAC1A  DA o͂ŎgƂ */

	if( waveSize != 0xffffffffUL )
	{
		waveSize -= (unsigned long)inBuffSize;
	}
	startDmaShort( &DMAC1A,					    	/* DMA WX^ */
					DMA_MODE_IO |					/* I/O [h	*/
					DMA_MODE_INC |					/* AhXCNg */
					DMA_FACT_ITU2 |	    			/* ITU2 RyA}b`œ]	*/
					DMA_MODE_WORD,                  /* ch0,1 𓯎ɓ]̂ WORD */
					(unsigned char*)waveBuffer,		/* g`f[^ */
					inBuffSize/2 );
 	ITU.TSTR.BIT.STR2 = 1; 							/* ITU2 Jn		*/

	return TRUE;
}

/****************************************************************************/
/* T  v																	*/
/*        DMA ]I荞												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        p DMA ]JnB										*/
/*        ]TCY inBuffSize B										*/
/****************************************************************************/
#pragma interrupt(InterruptDma1A)
void InterruptDma1A( void )
{
	clearDmaFactor(&DMAC1A);						/* 荞ݗvNA	*/

	/* ċN */
	startDmaShort( &DMAC1A,					    	/* DMA WX^ */
					DMA_MODE_IO |					/* I/O [h	*/
					DMA_MODE_INC |					/* AhXCNg */
					DMA_FACT_ITU2 |	    			/* ITU2 RyA}b`œ]	*/
					DMA_MODE_WORD,                  /* ch0,1 𓯎ɓ]̂ WORD */
					(unsigned char*)waveBuffer,		/* 11,025Hz sample, 8bit f[^ */
					inBuffSize/2 );
	dmaRepeatFlag = TRUE;							/* DMA ]obt@܂ԂtO	*/

}

/****************************************************************************/
/* T  v																	*/
/*        ^C}荞													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ^C}荞݁ADMA ~B									*/
/****************************************************************************/
#pragma interrupt(InterruptSound)
void InterruptSound( void )
{
	waveSize = 0ul;
	stopPlay( );
}

/****************************************************************************/
/* T  v																	*/
/*        Đ~														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ^C}荞݁ADMA ~B									*/
/****************************************************************************/
void stopPlay( void )
{
	ITU.TSTR.BIT.STR2 = 0; 							/* ITU2 ~		*/
	stopDma(&DMAC1A);								/* DMA ~			*/
	DA.DR0 = 128;
	DA.DR1 = 128;
}

