/****************************************************************************/
/* T  vF t@CVXe delete eXgpt@C						*/
/*   F 																*/
/* 쐬F 2005.06.09														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "TstWriteVal.h"
#include "TraceOut.h"
#include "TstDefine.h"

#define	TEST_FILE_NAME			"\\sub\\large.txt"
#define	TEST_ROOT_FILE_NAME		"\\root.txt"

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^t@C폜̃eXgs					*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestDelete( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long unitSize;								/* ݒ̃TCY */
	unsigned long len;									/* eXgΏۂ̃t@CTCY */

	TEST_TITLE(("Test delete file and directory."));
	TestReady();

	err = RfMkDir( "\\sub" );
	
	/* write(sub\large.txt) */
	pFcb = RfOpen( TEST_FILE_NAME, RF_OPEN_WRITE_NEW, &err );
	if( pFcb )
	{
		len = 32768UL;
		while( len )
		{
			unitSize = 4096;
			if( len < 4096 )	unitSize = len;
			err = RfWrite( pFcb, (char*)constWriteVal, &unitSize );
			len -= unitSize;
		}
		err = RfClose( pFcb );
	}

	/* write(root.txt) */
	pFcb = RfOpen( TEST_ROOT_FILE_NAME, RF_OPEN_WRITE_NEW, &err );
	if( pFcb )
	{
		len = 4096UL;
		err = RfWrite( pFcb, (char*)constWriteVal, &len );
		err = RfClose( pFcb );
	}

	/* delete file*/
	err = RfDelFile( TEST_FILE_NAME );
	CHK_ERR_CODE(err, RF_OK, "RfDelFile()");
	err = RfDelFile( TEST_ROOT_FILE_NAME );
	CHK_ERR_CODE(err, RF_OK, "RfDelFile()");
	err = RfDelFile( "\\sub" );
	CHK_ERR_CODE(err, RF_ERR_DIRECTORY, "RfDelFile()[NG]");

	/* delete dir */
	err = RfDelDir( "\\sub" );
	CHK_ERR_CODE(err, RF_OK, "RfDelDir()");

	/* I */
	err = RfConclude(  );
	CHK_ERR_CODE(err, RF_OK, "conclude");

	TestConclude();

}

